Package org.apache.sysds.runtime.compress.bitmap

## Class Bitmap

- java.lang.Object
- - org.apache.sysds.runtime.compress.bitmap.ABitmap
  - - org.apache.sysds.runtime.compress.bitmap.Bitmap

    public final class Bitmap
    extends ABitmap

Uncompressed representation of one or more columns in bitmap format.

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `getNumColumns()` Get the number of columns encoded in this bitmap
`int` `getNumNonZerosInOffset​(int idx)` Get the number of non zeros in a specific offset's tuple value.
`int` `getNumValues()` Obtain number of distinct value groups in the column.
`double[]` `getValues()` Get all values without unnecessary allocations and copies.

### Methods inherited from class org.apache.sysds.runtime.compress.bitmap.ABitmap

`containsZero, getNumOffsets, getNumOffsets, getNumZeros, getOffsetList, getOffsetsList, toString`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### getValues

    public final double[] getValues()

Get all values without unnecessary allocations and copies.

Returns:
  Dictionary of distinct values

#### getNumNonZerosInOffset

    public final int getNumNonZerosInOffset​(int idx)

Description copied from class: `ABitmap`
Get the number of non zeros in a specific offset's tuple value.

Specified by:
  `getNumNonZerosInOffset` in class `ABitmap`
Parameters:
  `idx` - The offset index to look at.
Returns:
  The nnz in the tuple.

#### getNumValues

    public final int getNumValues()

Description copied from class: `ABitmap`
Obtain number of distinct value groups in the column. this number is also the number of bitmaps, since there is one bitmap per value

Specified by:
  `getNumValues` in class `ABitmap`
Returns:
  number of distinct value groups in the column;

#### getNumColumns

    public int getNumColumns()

Description copied from class: `ABitmap`
Get the number of columns encoded in this bitmap

Specified by:
  `getNumColumns` in class `ABitmap`
Returns:
  The column count